(document:surround "/std/frame")
(document:insert "/std/functions")

(document:insert "/vm/functions")

(document:envelop with-attributes (option set-value! has-value? got-value need-value apply-value))

(document:envelop with-container-presentations
                                    ((option-widget '/vm/option option)))

(define (look-for-obj name)
  (let* ((devpath
           (let ((newpath
                   (string-split
                     (and (string-prefix? "/dev/evms/" name)
                          (substring name 10)) #\/)))
             (if (or (equal? "lvm2" (car newpath))
                     (equal? "md" (car newpath)))
               newpath
               (cons "disk"
                     (let*
                       ((newpath-unluksed
                          (if (string-suffix? "_luks" (car newpath))
                            (string-drop-right (car newpath) 5)
                            (car newpath)))
                        (newpath-trimmed (string-trim-right newpath-unluksed char-set:digit)))
                       (if (or
                             (string-prefix? "nvme" newpath-trimmed)
                             (string-prefix? "mmcblk" newpath-trimmed))
                         (if (string-suffix? "p" newpath-trimmed)
                           (cons (string-trim-right newpath-trimmed #\p) newpath)
                           newpath)
                         (if (equal? newpath-trimmed newpath-unluksed)
                           newpath
                           (cons newpath-trimmed newpath))))))))
         (subtree (member (vector
                            (cond
                              ((equal? "lvm2" (car devpath)) "LVM")
                              ((equal? "md" (car devpath)) "RAID")
                              (#t "Disks"))
                            "" "") (global 'tree)))
         (obj-vector
           (if (and (not (null? subtree)) (pair? devpath))
             (look-in-subtree (cadr subtree) (cdr devpath))
             #()))
         (fs-details
           (or (and (equal? (vector-ref obj-vector 2) "Unknown") "")
               (string-append
                 (if (string-null? (car (vector-ref obj-vector 2)))
                   ""
                   (string-append (_ "as ") (car (vector-ref obj-vector 2))))
                 " "
                 (if (string-null? (vector-ref obj-vector 3))
                   ""
                   (string-append (_ "mounted at ") (vector-ref obj-vector 3)))))))
    (cond
      ((equal? "lvm2" (car devpath))
       (string-join `("LVM VG" ,(cadr devpath)
                      "LV" ,(caddr devpath)
                      ,fs-details)))
      ((equal? "md" (car devpath))
       (string-join `("MD" ,(cadr devpath)
                      ,fs-details)))
      (#t
       (string-join `(,(_ "Partition")
                       ,(last devpath)
                       ,fs-details))))))

(define (look-in-subtree subtree path)
  (if (or (null? subtree) (null? path))
    subtree
    (let ((res
            (member path subtree
                    (lambda (x y)
                      (and (vector? y)
                           (equal? (car x) (car (vector-ref y 0))))))))
      (if (null? (cdr path))
        (car res)
        (look-in-subtree
          (cadr res)
          (cdr path))))))

(define (operation-details text type flag)
  (let ((pending (delete-duplicates (global 'operations))))
    (string-append text
                   "<br>"
                   (string-join
                     (map
                       (lambda (x)
                         (look-for-obj (car x)))
                       (filter
                         (lambda (x)
                           (and (equal? (cadr x) type)
                                (member flag (caddr x))))
                         pending))
                     "<br>"))))

(define (operation-list)
  (string-join
    (list
      (operation-details (_ "Pending operations:") 'volume 'activate))
    "<br><br>"))

(document:id changes-overview
             (gridbox width 480
                      (textbox (operation-list) alterability #f)
                      (label (_ "Apply requested changes?"))
                      (hbox
                        (button (_ "OK") (when clicked (document:end #t)))
                        (button (_ "Cancel") (when clicked (document:end #f))))))
